Note: This is a public test instance of Red Hat Bugzilla. The data contained within is a snapshot of the live data so any changes you make will not be reflected in the production Bugzilla. Email is disabled so feel free to test any aspect of the site that you want. File any problems you find or give feedback at bugzilla.redhat.com.

Bug 1960053

Summary: Starship is not updated
Product: [Fedora] Fedora Reporter: Tiago d'Almeida <tjamadeira>
Component: rust-starshipAssignee: Rust SIG <rust-sig>
Status: CLOSED ERRATA QA Contact: Fedora Extras Quality Assurance <extras-qa>
Severity: unspecified Docs Contact:
Priority: unspecified    
Version: 34CC: decathorpe, ego.cordatus, mauricio.teixeira, mike, rust-sig
Target Milestone: ---   
Target Release: ---   
Hardware: Unspecified   
OS: Unspecified   
Whiteboard:
Fixed In Version: rust-starship-0.54.0-1.fc35 rust-starship-0.54.0-1.fc34 Doc Type: If docs needed, set a value
Doc Text:
Story Points: ---
Clone Of: Environment:
Last Closed: 2021-06-06 21:31:44 UTC Type: Bug
Regression: --- Mount Type: ---
Documentation: --- CRM:
Verified Versions: Category: ---
oVirt Team: --- RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: --- Target Upstream Version:
Embargoed:
Bug Depends On: 1965494, 1965509, 1965524    
Bug Blocks:    

Description Tiago d'Almeida 2021-05-12 22:39:33 UTC
Description of problem:
Starship it isn't updated.
What can be done about this?

How reproducible:
Always.

Steps to Reproduce:
1. Install starship via dnf
2. See the version of it.

Actual results:
Actual version is 0.48.0

Expected results:
Version 0.53.0, maybe

Additional info:
https://bugzilla.redhat.com/show_bug.cgi?id=1922452
https://github.com/starship/starship/releases

Comment 1 Artem 2021-05-13 11:32:55 UTC
> What can be done about this?

Help with updating and maintaining it or use semi-automated COPR build[1].

Rust packaging in Fedora very time consuming task, but i believe in future things will be better. More automation and such.

[1]: https://copr.fedorainfracloud.org/coprs/atim/starship/

Comment 2 Fabio Valentini 2021-05-15 14:10:39 UTC
So ... do you plan to update the "official" starship package?

I'm already spending a lot of time keeping Rust crates in Fedora up-to-date, but I'm prioritizing that based on actual need - and I won't file review requests for new dependencies of *your* packages.

So if you're not planning to add the missing packages, it might be a better idea to orphan / retire it and direct people towards your COPR. That would also save me work, if the starship dependencies no longer need to be updated in Fedora.

Comment 3 Tiago d'Almeida 2021-05-27 17:19:01 UTC
Well ... I can try to update it. Please, @Fabio Valentini, how can I do that and help you a little bit?

Comment 4 Artem 2021-05-27 17:29:58 UTC
Current situation:

Error: 
 Problem 1: nothing provides requested (crate(attohttpc/form) >= 0.17.0 with crate(attohttpc/form) < 0.18.0~)
 Problem 2: nothing provides requested (crate(attohttpc/tls) >= 0.17.0 with crate(attohttpc/tls) < 0.18.0~)
 Problem 3: nothing provides requested (crate(git2) >= 0.13.19 with crate(git2) < 0.14.0~)
 Problem 4: nothing provides requested (crate(process_control/crossbeam-channel) >= 3.0.1 with crate(process_control/crossbeam-channel) < 4.0.0~)
 Problem 5: nothing provides requested (crate(process_control/default) >= 3.0.1 with crate(process_control/default) < 4.0.0~)
 Problem 6: nothing provides requested (crate(quick-xml/default) >= 0.22.0 with crate(quick-xml/default) < 0.23.0~)
 Problem 7: nothing provides requested (crate(regex/default) >= 1.5.4 with crate(regex/default) < 2.0.0~)
 Problem 8: nothing provides requested (crate(rust-ini/default) >= 0.17.0 with crate(rust-ini/default) < 0.18.0~)
 Problem 9: nothing provides requested (crate(serde/default) >= 1.0.126 with crate(serde/default) < 2.0.0~)
 Problem 10: nothing provides requested (crate(serde/derive) >= 1.0.126 with crate(serde/derive) < 2.0.0~)
 Problem 11: nothing provides requested (crate(shadow-rs/default) >= 0.5.25 with crate(shadow-rs/default) < 0.6.0~)
 Problem 12: nothing provides requested (crate(starship_module_config_derive/default) >= 0.2.1 with crate(starship_module_config_derive/default) < 0.3.0~)
 Problem 13: nothing provides requested (crate(sys-info/default) >= 0.9.0 with crate(sys-info/default) < 0.10.0~)
 Problem 14: nothing provides requested (crate(versions/default) >= 3.0.1 with crate(versions/default) < 4.0.0~)

Probably one we need one new crate to package. @Tiago Almeida i can add you co-maintainer and you can help with update. I wanted to do this at last weekend but... I don't mind orphan but in same time i don't want that *working* package was retired because i doubt that there is many people want to maintain rust software.

Comment 5 Tiago d'Almeida 2021-05-27 18:11:28 UTC
Ok, thanks for the report. I'll see what can I do and, yes, you can add me as co-maintainer.

Comment 6 Artem 2021-05-27 18:19:00 UTC
Great! What is your FAS name? I'll add you with full admin access. And i also try to package ASAP necessary new crates if there is need some.

@Fabio maybe you also interesting in this package? This awesome and handy software and nice to have official package.

Comment 7 Fabio Valentini 2021-05-27 18:31:46 UTC
I'm not using starship myself, so I'm probably not good comaintainer material - but I can work on some of the missing updates.

Note that it also looks like you queried an out-of-date repository cache:

- git2 updated to 0.13.19 a week ago
- regex updated to 1.5.4 a week ago
- serde updated to 1.0.126 a week ago

So at least those three should no longer be a problem.

New packages for the following crates will be needed:

- process_control
- shadow-rs
- versions

The following three crates can be freely updated to the required version, since starship is their only consumer in Fedora:

- attohttpc
- starship_module_config_derive
- sys-info

And then there are two crate updates that will need to be coordinated:

- quick-xml: also required by the latest crate(feed-rs) version, but blocked by missing dependencies of latest crate(newsflash)
- rust-ini: also required by crate(config), crate(silver), and crate(zram-generator); it may be possible to just bump the versions

======

I can try to prepare the necessary updates for attohttpc, starship_module_config_derive, sys-info as PRs, and I'll try to look at updating quick-xml and rust-ini and their dependent packages.

Comment 8 Tiago d'Almeida 2021-05-27 18:47:46 UTC
@

Comment 9 Tiago d'Almeida 2021-05-27 18:50:13 UTC
@Antem, my FAS is tjapro

Comment 10 Artem 2021-05-27 18:55:21 UTC
@Tiago, seems like your not in packager group? If so https://fedoraproject.org/wiki/Join_the_package_collection_maintainers

@Fabio thanks a lot. /me starting packaging new necessary crates...

Comment 11 Tiago d'Almeida 2021-05-27 19:00:04 UTC
@Antem, I'll see it. Thanks a lot!

Comment 13 Artem 2021-05-27 20:25:20 UTC
> if you want

Sure thing.

Comment 14 Fabio Valentini 2021-05-31 10:13:03 UTC
Do you want to update starship on f34 as well?
Then you need to request and build shadow-rs, versions, and process_control on f34 branches as well.

Comment 15 Artem 2021-06-04 08:20:51 UTC
(In reply to Fabio Valentini from comment #14)

f34 definitely wanted. So now politic allowed building modules for non-Rawhide branches? Nice if so.

Almost all ready for updating Starship...

Comment 16 Fabio Valentini 2021-06-04 08:23:00 UTC
No, Rust packages are just no longer *removed* from stable branches:
https://fedoraproject.org/wiki/Changes/Rust_Crate_Packages_For_Release_Branches
Building them on f34 now works just like on rawhide. Special process is only used for f33 any longer.

That's why I asked if you could build shadow-rs, versions, and process_control for f34 branch as well (you probably need to request those dist-git branches first).

Comment 17 Artem 2021-06-04 08:46:18 UTC
This is great TBH. I'll request and build them for f34 ASAP.

Dirty draft build with Starship 0.54 compiles fine for Rawhide[1]. Do you recommend waiting for rust-rust-ini and rust-sys-info updates? OK if so. Waiting for you command then.

[1]: https://koji.fedoraproject.org/koji/taskinfo?taskID=69288664

Comment 18 Fabio Valentini 2021-06-04 08:48:49 UTC
I need to build the rust-rust-ini updates in a side tag either way (because three packages need patches for the new version), so I would build everything including starship in that side tag in then submit everything as one update.

Comment 19 Fedora Update System 2021-06-06 21:31:44 UTC
FEDORA-2021-2a21ea5cf3 has been pushed to the Fedora 35 stable repository.
If problem still persists, please make note of it in this bug report.

Comment 20 Fedora Update System 2021-06-06 21:32:24 UTC
FEDORA-2021-889f3ea6f9 has been submitted as an update to Fedora 34. https://bodhi.fedoraproject.org/updates/FEDORA-2021-889f3ea6f9

Comment 21 Fedora Update System 2021-06-07 01:29:53 UTC
FEDORA-2021-889f3ea6f9 has been pushed to the Fedora 34 testing repository.
Soon you'll be able to install the update with the following command:
`sudo dnf upgrade --enablerepo=updates-testing --advisory=FEDORA-2021-889f3ea6f9`
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2021-889f3ea6f9

See also https://fedoraproject.org/wiki/QA:Updates_Testing for more information on how to test updates.

Comment 22 Tiago d'Almeida 2021-06-13 00:41:22 UTC
@Antem, Sorry for my delay.
Can you try again, please? 
My FAS is tjapro

Comment 23 Artem 2021-06-14 10:23:11 UTC
(In reply to Tiago d'Almeida from comment #22)
You not in packager group https://accounts.fedoraproject.org/user/tjapro/

Your first step is https://fedoraproject.org/wiki/Join_the_package_collection_maintainers

Also updating Starship is not limited to trivial bumping starship version itself. There is a lot updating/fixing modules/dependencies work. So if you really want to help you also need to be in 'rust-sig' group.

Comment 24 Fedora Update System 2021-06-15 01:05:02 UTC
FEDORA-2021-889f3ea6f9 has been pushed to the Fedora 34 stable repository.
If problem still persists, please make note of it in this bug report.

Comment 25 Tiago d'Almeida 2021-06-27 17:48:54 UTC
Thanks!